# /etc/hosts

## Lesson Content

Before our machine actually hits DNS to do a query, it first looks locally on our machines. 

<b>/etc/hosts</b>

The /etc/hosts file contains mappings of some hostnames to IP addresses. The fields are pretty self explanatory, there is one for the IP address, the hostname and then any alias's for the host. 

<pre>
pete@icebox:~$ cat /etc/hosts
127.0.0.1       localhost
127.0.1.1       icebox
</pre>

You'll typically see your localhost address listed as a default in this file. You can also manage access to hosts by modifying the /etc/hosts.deny or /etc/hosts.allow files. However, if you were security conscientious, this isn't really the way to go and you should be modifying your firewall rules instead. 

Let's see a fun example of /etc/hosts. Modify the file and add a line for:

<pre>
123.45.6.7  www.google.com
</pre>

Save the file and now go to www.google.com. Having issues aren't you? Well that's because we just mapped www.google.com to a completely wrong IP address. Since our hosts first look locally for IP address mappings, it never reaches DNS to find google.com. 

<b>/etc/resolv.conf</b>

Traditionally, we've used a file called /etc/resolv.conf to map DNS name servers for more efficient lookups, however with the improvements made to DNS this file is quite often irrelevant, in fact, you can see in my example below that /etc/resolv.conf isn't managed manually. Refer to your distribution specific settings to manage DNS name server mappings.

<pre>
conf(5) file for glibc resolver(3) generated by resolvconf(8)
#     DO NOT EDIT THIS FILE BY HAND -- YOUR CHANGES WILL BE OVERWRITTEN
nameserver 127.0.1.1
search localdomain
</pre>

## Exercise

No exercises for this lesson.

## Quiz Question

What file is used to map hostnames to IP addresses on our machines?

## Quiz Answer

/etc/hosts