# Signals

## Lesson Content

A signal is a notification to a process that something has happened.

<b>Why we have signals</b>

They are software interrupts and they have lots of uses:

<ul>
<li>A user can type one of the special terminal characters (Ctrl-C) or (Ctrl-Z) to kill, interrupt or suspend processes</li>
<li>Hardware issues can occur and the kernel wants to notify the process</li>
<li>Software issues can occur and the kernel wants to notify the process</li>
<li>They are basically ways processes can communicate</li>
</ul>

<b>Signal process</b>

When a signal is generated by some event, it's then delivered to a process, it's considered in a pending state until it's delivered. When the process is ran, the signal will be delivered. However, processes have signal masks and they can set signal delivery to be blocked if specified. When a signal is delivered, a process can do a multitude of things: 

<ul>
<li>Ignore the signal</li>
<li>"Catch" the signal and perform a specific handler routine</li>
<li>Process can be terminated, as opposed to the normal exit system call</li>
<li>Block the signal, depending on the signal mask</li>
</ul>

<b>Common signals</b>

Each signal is defined by integers with symbolic names that are in the form of SIGxxx. Some of the most common signals are: 

<ul>
<li>SIGHUP or HUP or 1: Hangup</li>
<li>SIGINT or INT or 2: Interrupt</li>
<li>SIGKILL or KILL or 9: Kill</li>
<li>SIGSEGV or SEGV or 11: Segmentation fault</li>
<li>SIGTERM or TERM or 15: Software termination</li>
<li>SIGSTOP or STOP: Stop</li>
</ul>

Numbers can vary with signals so they are usually referred by their names.

Some signals are unblockable, one example is the SIGKILL signal. The KILL signal destroys the process.

## Exercise

No exercises for this lesson.

## Quiz Question

What signal is unblockable?

## Quiz Answer

SIGKILL