# دستکاری مجوزها

## محتویات درس

شما با استفاده از فرمان **chmod** به راحتی می‌توانید مجوزها را تغییر دهید.

ابتدا دسته‌ی مجوزی که می‌خواهید تغییر دهید را انتخاب کنید. دسته‌ی کاربر، گروه و یا دیگران. حالا می‌توانید با استفاده از **+** و **-** آن‌ها را اضافه یا حذف کنید. با هم نگاهی به چند مثال می‌اندازیم.

**اضافه کردن یک بیتِ مجوز به فایل**

```$ chmod u+x myfile```

دستور بالا اینگونه خوانده می‌شود: مجوز فایل myfile را با اضافه کردن قابلیت اجرا به مجوزهای دسته‌ی کاربر، تغییر بده. در نتیجه کاربر از این به بعد مجوز اجرا کردن این فایل را خواهد داشت.

لازم به ذکر است که منظور از کاربر، کاربری‌ست که خط فرمان را در اختیار دارد و در حال اجرای دستور یا فرمان است.


**حذف بیتِ مجوز از یک فایل**

```$ chmod u-x myfile```

**اضافه کردن چند بیتِ مجوز به یک فایل**

```$ chmod ug+w```

یک راه دیگر نیز برای عوض کردن مجوزها استفاده از فرمت عددی است. این روش به شما اجازه‌ی تغییر تمامی مجوزها را در آن واحد می‌دهد. به جای استفاده از r و w و یا x برای اضافه و کم کردن بیت مجوزها می تواند از یک عدد برای یک دسته از مجوزها استفاده کنید. به عبارتی دیگر لازم نیست که از u برای کاربر و از g برای مشخص کردن گروه استفاده کنید.

نمونه‌های عددی را در زیر می‌توانید ببینید:


+ 4: مجوز خواندن
+ 2: مجوز نوشتن
+ 1: مجوز اجرا شدن

نگاهی به یک مثال بیندازیم:

```$ chmod 755 myfile```

می‌توانید حدس بزنید که در دستور بالا، چه مجوزهایی به فایل مورد نظر ما داده شده است؟ 775 کلِ دسته‌ی مجوزهای ما را مورد پوشش خود قرار می‌دهد. اولین عدد یعنی (7) مجوزهای کاربر، دومین عدد یعنی (5) مجوزهای گروه و سومین عدد یعنی (5) هم مجوزهای سایرین را تعیین می‌کند.

ولی ۵ و ۷ که جزو عددهای بالا نیستند؟ این عددها از کجا آمده‌اند؟ از آنجایی که قرار است کل مجوزهای کاربر یا گروه یا سایرین با استفاده از یک عدد انجام شود، شاید بد نباشد کمی هم ریاضیات را در این کار دخالت دهیم. اما چطور؟

با مجوز کاربر یعنی عدد (7) شروع کنیم. این عدد برابر است با: 7 = 4 + 2 + 1 به عبارتی هفت مجموع عدد سه مجوز خواندن، نوشتن و ا جرا شدن است و در نتیجه کاربر هر سه مجوز را دارد.

گروه و سایرین (تمامی دیگر کاربران) که به ترتیب دو عدد بعدی نماینده‌ی آن‌ها هستند با (5) مشخص شده‌اند. پنج مجموع عددهای 1 و 4 است و به عبارتی گروه و سایرین مجوز خواندن و اجرا کردن فایل مورد نظر را دارند.

و البته یک نکته‌ی دیگر و آن اینکه به صورت هوا و هوسی و دل‌بخواهی مجوزها را دستکاری نکنید چرا که ممکن است فایل‌های حساس را در معرض سوءاستفاده‌ی سایرین قرار دهید و برای خودتان دردسر درست کنید. برای استفاده کاربردی و درست از chmod بهترین کار این است که جانب احتیاط را رعایت کنید و قبل از انجام تغییر مجوزها، دستور را بررسی کنید. به هر حال در بسیاری از مواقع نیاز به آن خواهید داشت و اگر هوشیارانه از آن استفاده کنید هیچگونه خطری را برای خود به جان نخواهید خرید.


## تمرین

مجوزهای چند فایل ساده‌ی متنی را تغییر دهید و تغییرات ایجاد شده در بیت‌های آن را با استفاده از دستور ls -l رویت کنید.


## سوال آزمون

در فرمت عددی مجوزها، چه عددی نشان‌دهنده‌ی مجوز خواندن برای یک فایل است؟


## پاسخ آزمون

4
