# مجوزهای یک پروسه

## محتویات درس

نوبت به مجوزهای پروسه «Process» رسید. یادتان هست که گفتم اجرای دستور passwd وقتی که بیت مجوز SUID فعال است برنامه را با دسترسی روت اجرا می‌کند؟ این موضوع، درست است، ولی آیا به این معناست که زمانی که به صورت موقتی کاربر روت هستید می‌توانید پسورد سایر کاربران را نیز تغییر دهید؟ خوشبختانه خیر!

این اتفاق به خاطر UIDهای زیادی که لینوکس به کار برده است، می‌افتد. سه UID به هر پروسه‌ای گره خورده است:

زمانی که یک پروسه را اجرا می‌کنید، این پروسه با مجوزهایی مشابه با مجوزهای کاربر و گروهی که آن را شروع کرده‌اند، اجرا می‌شود. این مورد به عنوان **شناسه‌ی کاربر تحت تأثیر** یا **effective user ID** شناخته می‌شود. این UID برای اعطای مجوزهای دسترسی به یک پروسه استفاده می‌شود. بنابراین اگر Bob دستور touch را اجرا کند، آن پروسه با شناسه‌ی او اجرا شده و هر فایلی که توسط آن ساخته شود به مالکیت Bob در خواهد آمد.

البته یک UID دیگر به اسم **شناسه کاربر حقیقی** یا **real user ID** نیز هست که به شناسه کاربری که پروسه را شروع کرده اطلاق می‌شود. این شناسه‌ها برای پیگیری کاربری که پروسه را اجرا کرده، مورد استفاده قرار می‌گیرد.

آخرین UID، **شناسه کاربر ذخیره‌شده** یا **saved user ID** است که به یک پروسه اجازه می‌دهد تا از شناسه‌ی تحت تأثیر به شناسه‌ی حقیقی و بالعکس تغییر کند. این UID به این دلیل به دردبخور است که ما همیشه نمی‌خواهیم پروسه‌هایمان با دسترسی‌های اعطا شده‌‌ی دارای مجوزهای بالا اجرا شوند. به عبارتی کار درست این است که در زمان‌های خاص از مجوزهای خاص استفاده کنیم.

اکنون با نگاهی به فرمان passwd تکه‌های پازلمان را به یکدیگر می‌چسبانیم.

زمانی که فرمان passwd اجرا می‌شود، شناسه‌ی کاربر تحت تأثیر همان شناسه‌ی کاربر شماست، فرض کنید اکنون این شناسه 500 است. خب ولی یک نکته اینجاست، دستور passwd یک مجوز فعال SUID نیز دارد. در نتیجه زمانی که شما آن را اجرا می‌کنید، شناسه‌ی کاربر تحت تأثیر 0 است (0 شناسه‌ی کاربر روت است). در نتیجه برنامه به فایل با مجوز روت، دسترسی دارد.

حالا که مزه‌ی قدرت زیر زبانتان آمد شاید بد نباشد که پسورد Sally را هم عوض کنید. Sally شناسه‌ی کاربر 600 دارد. شانس با شما یار نیست چرا که خوشبختانه پروسه، شناسه کاربر حقیقی شما را نیز دارد که در مثال ما 500 است. به عبارتی به این خاطر که شناسه‌ی کاربرتان 500 است و پروسه این موضوع را می‌داند، نمی‌توانید پسورد کسی که شناسه‌ی کاربرش 600 است را تغییر دهید. (البته این مورد اگر شما یک سوپریوزر یا superuser بر روی دستگاه باشید می‌تواند دور زده شود و کنترل تمام قسمت‌های سیستم من جمله تغییر پسوردها را به دستتان بسپارد).

با توجه به اینکه شما passwd را اجرا می‌کنید، فرمان، پروسه را با شناسه کاربر حقیقی (real UID) اجرا کرده و سپس و شناسه‌ی کاربر صاحب فایل را ذخیره می‌کنید (شناسه کاربر تحت تأثیر یا effective UID) در نتیجه شما می‌توانید بین این شناسه‌ها عقب و جلو شوید. در حقیقت نیازی نیست در زمانی که الزام به تغییر با دسترسی روت وجود ندارد، همه‌ی فایل‌ها را با مجوز روت دستکاری کنید.

بیشتر اوقات شناسه کاربر حقیقی و شناسه کاربر تحت تأثیر یکی هستند اما در برخی موقعیت‌ها مانند زمانی که از فرمان passwd استفاده می‌کنید، آن‌ها تغییر می‌کنند.

## تمرین

ما هنوز در خصوص پروسه‌ها صحبت نکرده‌ایم ولی می‌توانیم این تغییرات را در حال حاضر ملاحظه کنیم:

+ یک پنجره ترمینال باز کنید و دستور **watch -n 1 "ps aux | grep passwd"‎** را صادر کنید. این کار پروسه‌ی passwd را زیر نظر می‌گیرد.
+ یک ترمینال دیگر باز کنید و دستور **passwd** را اجرا کنید.
+ حالا به پنجره‌ی اولی که باز کردید نگاه بیندازید. می‌بینید که یک پروسه برای passwd اجرا شده است.
+ اولین ستون در جدول پروسه، شناسه کاربر تحت تأثیر است. و نگاه کنید! اینکه کاربر روت است!

## سؤال آزمون

چه شناسه‌ی کاربری تصمیم می‌گیرد که چه دسترسی‌هایی را به پروسه اعطا کند؟

## پاسخ آزمون

effective
