# Setuid

## محتویات درس

خیلی اوقات پیش می‌آید که کاربرهای عادی برای انجام کاری، به دسترسی به چیزی بیش از آنچه یک کاربر می‌تواند داشته باشد، نیاز دارند. مدیر سیستم هم که نمی‌تواند دائم آنجا حضور داشته باشد تا پسورد روت را هر بار که یک کاربر نیاز به دسترسی به یک فایل محافظت‌شده دارد، وارد کند. برای همین منظور بیت‌های مجوز خاصی طراحی شده‌اند که در ادامه شما را با آن‌ها آشنا می‌کنیم. SUID به کاربرها اجازه می‌دهد که برنامه‌ها را به عنوان صاحب یک فایل به اجرا در آوردند، در حالی که صاحب اصلی فایل می‌تواند کاربر دیگری باشد.

با هم نگاهی به یک مثال بیندازیم:

فرض کنید که می‌خواهیم پسوردمان را عوض کنیم. ساده است. درست؟ از فرمان  passwd به این منظور استفاده می‌کنیم.

```$ passwd```

فرمان بالا چه کاری را انجام می‌دهد؟ این فایل چند فایل مختلف من جمله فایل بسیار حیاتی ‎/etc/shadow را دستکاری می‌کند. حالا نگاهی به فایل مذکور بیندازیم.

```$ ls -l /etc/shadow```

```-rw-r----- 1 root shadow 1134 Dec 1 11:45 /etc/shadow```

چی شد؟ صاحب این فایل کاربر روت است و کاربران دیگر حق دخل و تصرف در فایل مذکور را ندارند؟ چطور ما به عنوان یک کاربر عادی توانستیم یک فایل متعلق به روت را دستکاری کنیم؟

نگاهی به دسته‌ی دیگری از مجوزها بیندازیم. این بار دسته مجوزهای خودِ فرمان اجرا شده یعنی passwd.

```$ ls -l /usr/bin/passwd```

```-rwsr-xr-x 1 root root 47032 Dec 1 11:45 /usr/bin/passwd```

اینجا به یک بیت مجوز تازه‌ای با نام **s** برمی‌خوریم. این بیت مجوز، SUID نام دارد و زمانی که یک فایل، این بیت مجوز را دارد، به کاربری که آن برنامه را اجرا می‌کند اجازه داده می‌شود تا مجوز مالکیت فایل در کنار اجازه‌ی اجرا را داشته باشد، که در مثال ما این مجوزها مربوط به کاربر ریشه است. در حقیقت زمانی که یک کاربر، فرمان پسورد را وارد می‌کند، این کار را به عنوان کاربر روت انجام می‌دهد و در نتیجه اجازه‌ی دستکاری در فایل به آن کاربر داده می‌شود.

به همین خاطر است که ما اجازه‌ی دسترسی به فایل محافظت‌شده‌ای نظیر ‎/etc/shadow را زمانی که فرمان passwd را اجرا می‌کنیم، داریم. اکنون اگر شما آن بیت مجوز را حذف کنید خواهید دید که دیگر قادر به دستکاری فایل ‎/etc/shadow و تغییر کلمه‌ی عبور خودتان نخواهید بود.

**ویرایش SUID**

درست شبیه به مجوزهای عادی دو راه برای دستکاری مجوزهای SUID وجود دارد.

*با استفاده از نمادها*

```$ sudo chmod u+s myfile```

*با استفاده از اعداد*

```$ sudo chmod 4755 myfile```

همانطور که مشاهده می‌کنید SUID با عدد ۴ مشخص می‌شود و در ابتدای دسته‌ی مجوزها جای می‌گیرد. همچنین ممکن است که شما SUID را با **S** بزرگ ببینید که این بدین معنی‌ست که فایل مورد اشاره، مجوز اجرا ندارد.

## تمرین

به ریزِ مجوزهای فایل ‎/etc/passwd نگاهی بیندازید. چیز دیگری نظرتان را جلب کرد؟ فایل‌های با SUID فعال، به راحتی قابل تمایز هستند.

## سؤال آزمون

چه عددی نمایش‌دهنده‌ی SUID است؟

## پاسخ آزمون

4
