# فرآیند بوت: BIOS

## محتوای درس

**BIOS**

اولین مرحله در فرآیند بوت ‌BIOS است که وضعیت سیستم را بررسی می‌کند. BIOS فرم‌ویری
عمومی است که در اکثر کامپیوتر‌های مبتنی بر کامپیوتر‌های IBM (اغلب کامپیوتر‌های
موجود) قرار دارد. احتمالا شما هم از فرم‌ویر BIOS برای تغییر چیدمان بوت، بررسی
زمان سیستم‌، بررسی مک آدرس سیستم و یا … استفاده کرده‌اید. هدف اصلی BIOS‌، یافتن
bootloader سیستم است.

زمانی که BIOS‌، دیسک سخت را بوت می‌کند، به دنبال بلاک بوت (Boot Block) می‌گردد تا
چگونگی بوت سیستم را پیدا کند. بسته به چگونگی پارتیشن‌بندی دیسک سخت‌تان‌، BIOS به
دنبال master boot record (MBR)‎ یا GPT می‌گردد. MBR، در اولین بخش دیسک سخت (۵۱۲
بایت اول) قرار می‌گیرد و شامل کدی برای بارگذاری برنامه‌ای دیگر از روی دیسک سخت
می‌شود. در حقیقت این برنامه وظیفهٔ بارگذاری bootloader را بر عهده دارد.

حال اگر دیسک سخت‌تان را با GPT پارتیشن‌بندی کرده باشید‌، موقعیت bootloader کمی فرق دارد.

**UEFI**

روش دیگری نیز برای بوت کردن به غیر از BIOS وجود دارد که UEFI نام دارد. UEFI مخفف
عبارت Unified Extensible Firmware Interface یا به عبارتی «رابط یک‌پارچه و قابل
گسترش فرم‌ویر» است. UEFI به عنوان جایگزین BIOS طراحی شد و اکثر سخت‌افزار‌هایی که
امروزه عرضه می‌شوند از این فرم‌ویر استفاده می‌کنند. ماشین‌های مکینتاش‌، سال‌هاست که از
پروسهٔ بوت EFI بهره می‌برند و ویندوز هم اکثر تشکیلاتش را به پروسهٔ بوت UEFI منتقل
کرده است. فرمت GPT، برای استفاده با EFI تعیین شده است. عملا اگر از دیسک‌های GPT
بهره می‌برید‌، ملزم به استفاده از EFI نیستید. اولین بخش یک دیسک GPT به عنوان
«Protective MBR» در نظر گرفته شده که بوت کردن این نوع پارتیشن‌بندی دیسک را با یک
ماشین بر مبنای BIOS ممکن می‌سازد.

‏UEFI تمام اطلاعات مربوط به فرآیند شروع را در یک فایل ‎.efi ذخیره می‌کند. این فایل
در یک پارتیشن مخصوص به اسم EFI system partition روی سخت‌افزار قرار دارد. همچنین
این پارتیشن شامل bootloader نیز می‌شود. UEFI نسبت به BIOS شامل بهبود‌های بسیاری
است. اما به هر حال‌، چون ما از لینوکس استفاده می‌کنیم، اکثرمان در حال بهره‌گیری از
BIOS هستیم. و بر همین اساس ادامهٔ مباحث بر همین اصل ادامه خواهد یافت.

## تمرین

به منوی BISO خود بروید و بررسی کنید که آیا UEFI booting فعال است یا خیر.

## سوال آزمون

‏BIOS چه چیزی را بارگذاری می‌کند؟

## پاسخ

bootloader
