# فرآیند بوت: Bootloader

# محتوای درس

مسئولیت‌های اصلی bootloader شامل موارد زیر است:

- بوت کردن یا راه‌اندازی یک سیستم عامل که البته شامل امکان بوت کردن سیستم‌عامل‌های غیر-لینوکسی هم می‌شود.
- انتخاب یک کرنل (Kernel) برای استفاده.
- مشخص کردن پارامتر‌های کرنل.

معروف‌ترین bootloader لینوکس‌، گراب (GRUB) است که احتمالا شما هم روی سیستم‌تان از
آن استفاده می‌کنید. البته bootloader‌های دیگری همچون LILO, efilinux, coreboot,
SYSLINUX و بسیاری دیگر نیز وجود دارند که می‌توانید از آن‌ها نیز بهره ببرید. اما ما
به هر حال در ادامهٔ بحث فرض می‌کنیم که از گراب به عنوان bootloader استفاده می‌کنیم.

پس می‌دانیم که هدف اصلی bootloader بارگذاری کرنل است. اما او از کجا می‌تواند کرنل
را پیدا کند؟ برای پیدا کردن کرنل‌، نیاز است که به پارامتر‌های کرنل نگاهی
بیاندازیم. این پارامتر‌ها در منوی گراب و زمان شروع سیستم با زدن کلید «e» قابل
مشاهده‌اند. اگر گراب ندارید‌، نگران نباشید، با هم پارامتر‌هایی که ممکن است ببینید
را مرور می‌کنیم:

- ‏`initrd`: محل RAM disk اولیه را مشخص می‌کند (در درس بعدی‌، در این خصوص بیشتر صحبت خواهیم کرد).
- ‏`BOOT_IMAGE`: نشان دهندهٔ جایی است که کرنل قرار گرفته است.
- `root`: محل فایل سیستم root را نشان می‌دهد. کرنل در این فایل سیستم به دنبال init
  می‌گردد. این فایل سیستم عموما با مشخصهٔ UUID یا اسم دستگاه ماننده `‎/dev/sda1` مشخص
  می‌شود.
- `ro`: این پارامتر کاملا استاندارد است. وظیفه‌اش بارگذاری فایل سیستم root با دسترسی فقط خواندنی (read only) است.
- `quiet`: با اضافه شدن این پارامتر‌، شما پیغام‌هایی که در هنگام بارگذاری کرنل نمایش داده می‌شوند را مشاهده نمی‌کنید.
- `splash`: این پارامتر اجازه می‌دهد Splash screen در هنگام بارگذاری نمایش داده شود.

## تمرینات

اگر از bootloader گراب استفاده می‌کنید‌، به منوی گراب رفته و کلید «e» را بزنید و به تنظیماتش نگاهی بیاندازید.

## سوالات آزمون

کدام پارامتر کرنل از نمایش پیغام‌های بوت در هنگام بارگذاری کرنل جلوگیری می‌کند؟

## پاسخ آزمون

```
quiet
```
