# انواع فایل‌سیستم

## محتویات درس

چندین و چند نوع فایل‌سیستم در دسترس کاربران است که تعدادشان واقعاً کم نیست. برخی از آن‌ها از بقیه سریع‌ترند و بعضی فضاهای ذخیره‌ساز با ظرفیت بالا را به خوبی پشتیبانی می‌کنند و تعدادی تنها برای فضاهای ذخیره‌ساز با ظرفیت پایین‌تر مناسب هستند. فایل‌سیستم‌های متفاوت، روش‌های متفاوتی را برای سامان دادن به اطلاعات به کار می‌گیرند و ما در اینجا وارد جزئیات بیشتری از آن‌ها خواهیم شد. از آنجایی که انواع مختلف فایل‌سیستم موجود است، برنامه‌ها به راه‌هایی برای تعامل با عامل‌های مختلف نیاز دارند. به همین دلیل چیزی به اسم لایه‌ی انتزاعی VFS یا فایل‌سیستم‌مجازی وجود دارد. این لایه، بین انواع مختلف فایل‌سیستم و برنامه‌ها قرار می‌گیرد. در نتیجه، نوعِ فایل‌سیستم برای کارکرد درست برنامه، دیگر مهم نخواهد بود و به هر حال برنامه می‌تواند با آن فایل‌سیستم کار کند.

شما می‌توانید تعداد زیادی فایل‌سیستم بر روی دیسک خود داشته باشید و این موضوع بستگی به نحوه‌ی پارتیشن‌بندی دیسک دارد. ما به این مسأله در دروس پیشِ رو خواهیم پرداخت.

**ژورنالینگ**

ژورنالینگ را بهتر است با همین نام فرنگی بشناسید. این ویژگی در اکثر فایل‌سیستم‌ها به صورت پیش‌فرض وجود دارد. ولی ژورنالینگ دقیقاً چیست؟ فرض کنید در حال کپی کردن یک فایل حجیم هستید و یک دفعه برق قطع می‌شود. اگر در حال انجام عملیات بر روی یک فایل‌سیستم غیر-ژورنالی باشید، نهایتاً با یک فایل خراب روبرو می‌شوید و فایل‌سیستمِ شما، آن یک‌پارچگی خود را از دست می‌دهد. بعد که سیستم را دومرتبه روشن کردید، یک بررسی فایل‌سیستم در دستور کار آن برای اطمینان از عمل‌کرد صحیحِ همه‌چیز، قرار خواهد گرفت. و این بررسی و تعمیر، بسته به اندازه‌ی فایل‌سیستم مدت زمانی را به طول خواهد انجامید.

حالا فرض کنید که بر روی یک فایل‌سیستم با قابلیت ژورنالینگ بودید. قبل از اینکه سیستم شروع به کپی کردن فایل کند، کاری که شما در شُرف انجامش هستید را در یک فایلِ لاگ ژورنال می‌کند و یا به عبارت ساده‌تر می‌نویسد. حالا وقتی که کپی کردن آن فایل تمام شد، ژورنال آن وظیفه را در لاگ به عنوان یک کار تکمیل شده، نشانه‌گذاری می‌کند. به این صورت فایل‌سیستم همیشه در حالت یک‌پارچه قرار دارد، چون دقیقاً می‌داند زمانی که سیستم به یک‌باره خاموش شد، شما در حال انجام چه کاری بوده‌اید. این کار، زمان راه‌اندازی را نیز کاهش می‌دهد، چرا که به جای بررسی کلِ فایل‌سیستم، فقط کافی‌ست که سیستم‌عامل نگاهی به ژورنال شما کند.

**انواعِ معمول فایل‌سیستم‌های دسکتاپ**

+ ext4 – جدیدترین نسخه از فایل‌سیستم اصلی لینوکس است. این فایل‌سیستم با نسخه‌های قبلی یعنی ext2 و ext3 سازگار است و دیسک‌هایی تا حجم یک اگزابایت و فایل‌هایی تا اندازه‌ی ۱۶ ترابایت را پشتیبانی می‌کند.
+ Btrfs – این فایل‌سیستمِ جدید لینوکسی با قابلیت اسنپ‌شات، بک‌آپ‌های افزایشی، عمل‌کرد بهتر و بسیاری ویژگی‌های دیگر عرضه شده است. این فایل‌سیستم در اکثر سیستم‌ها در دسترس است ولی به خاطر سازگاری و پایداری نه‌چندان کاملش، زیاد مورد استفاده قرار نمی‌گیرد. بک‌آپ افزایشی، به پشتیبان‌گیری گفته می‌شود که در آن به جای ایجاد یک فایل پشتیبان جدید، فایل قبلی به روز می‌شود و به این صورت مدت زمان کمتری برای پشتیبان‌گیری هدر می‌رود.
XFS – یک فایل‌سیستم با قابلیت ژورنالینگ و عمل‌کرد بسیار بالا که مناسب سیستم‌هایی با فایل‌های بزرگ مانند مدیا-سرورها است.
NTFS و FAT – فایل‌سیستم‌های ویندوزی.
+ ‎HFS+‎ – فایل‌سیستم مکینتاش.

حالا نوبت شماست که ببینید چه فایل‌سیستم‌هایی بر روی کامپیوتر شما جای خوش کرده‌اند.

```
pete@icebox:~$ df -T
Filesystem     Type     1K-blocks    Used Available Use% Mounted on
/dev/sda1      ext4       6461592 2402708   3707604  40% /
udev           devtmpfs    501356       4    501352   1% /dev
tmpfs          tmpfs       102544    1068    101476   2% /run
/dev/sda6      xfs       13752320  460112  13292208   4% /home
```

دستور **df** گزارشی از فضای استفاده شده‌ی فایل‌سیستم و جزئیاتی دیگر را به شما نشان می‌دهد. ما در خصوص این ابزار در آینده صحبت خواهیم کرد.

## تمرین

یک تحقیق کوچک پیرامون فایل‌سیستم‌های دیگر انجام دهید: ReiserFS, ZFS, JFS و هر چیز دیگری که پیدا کردید.

## سؤال آزمون

پر استفاده‌ترین فایل‌سیستم لینوکسی چیست؟

## پاسخ آزمون

ext4
