# Inodes (آی‌نودها)

## محتویات درس

خاطرتان هست که چطور فایل‌سیستم از فایل‌های واقعیِ ما، و پایگاه‌داده برای مدیریت این فایل‌ها استفاده می‌کرد؟ آن پایگاه داده به عنوان جدول **آی‌نود** شناخته می‌شود.

**یک آی‌نود چیست؟**

یک آی‌نود (index node) یک ورودی در جدول مذکور است که در آن جدول برای هر فایل یک عدد از آن (آی‌نود) موجود است.  آی‌نود توضیح تمام چیزهایی‌ست که یک فایل دارد. مانند:

+ نوع فایل – فایل معمولی، دایرکتوری، کاراکتر دیوایس که اجازه‌ی دسترسی به سخت‌افزار را به صورت مستقیم فراهم می‌کند و غیره
+ صاحب
+ گروه
+مجوزهای دسترسی
+ تایم‌استمپز – mtime (زمان آخرین دستکاری فایل)، ctime (زمان آخرین تغییر ویژگی فایل)، atime (زمان آخرین دسترسی به فایل)
+ تعداد لینک‌های سخت به یک فایل (هاردلینک)
+ اندازه یا حجم فایل
+ تعداد بلاک‌هایی که توسط فایل اشغال شده است
+ نشانگر به بلاک‌های داده‌ی فایل – مهم‌ترین اطلاعاتی که آی‌نود دارد، همین است

در اصل آی‌نود تمام جزئیات فایل را می‌داند به غیر از نام و البته خودِ فایل.

**چه زمانی آی‌نودها ساخته می‌شوند؟**

زمانی که فایل‌سیستم را می‌سازید، فضایی هم برای آی‌نودها اختصاص داده می‌شود. بر اساس اطلاعاتی مانند حجم دیسک و غیره، فضایی برای آی‌نود در نظر گرفته می‌شود. حتماً شده که با خطای «دیسک سخت پر شده» در طول عمر خود مواجه شده‌اید. این مورد برای آی‌نودها هم می‌تواند اتفاق بیفتد (هرچند نادرتر است). آی‌نودهای شما ممکن است تمام شود و به تبع آن قادر نباشید که فایل‌های جدیدی را بسازید. همیشه در خاطرتان باشد که ذخیره‌ساز اطلاعات به خود اطلاعات و پایگاه داده‌‌ی این اطلاعات (یا همان آی‌نود) وابسته است.

برای دیدن مقدار باقیمانده‌ی آی‌نودهای موجود بر روی سیستم خود می‌توانید از دستور **df -i** استفاده کنید.

**اطلاعات آی‌نود**

آی‌نودها با اعداد شناسایی می‌شوند. زمانی که یک فایل ساخته می‌شود، یک شماره‌ی آی‌نود به آن تعلق می‌گیرد. این اعداد به ترتیب، یکی پس از دیگری به فایل‌ها اختصاص داده می‌شود. هر چند بعضی وقت‌ها می‌بینید که شماره‌ی آی‌نودی که به فایل جدید اختصاص داده شده است، پایین‌تر از برخی دیگر از آی‌نودهاست. چرا این اتفاق می‌افتد؟ زمانی که یک آی‌نود حذف می‌شود، آن‌ها آماده‌ی استفاده مجدد برای فایل‌‌های دیگر می‌شوند. برای دیدن شماره‌ی آی‌نود می‌توانید از فرمان **ls -li** استفاده کنید.

```
pete@icebox:~$ ls -li
140 drwxr-xr-x 2 pete pete 6 Jan 20 20:13 Desktop
141 drwxr-xr-x 2 pete pete 6 Jan 20 20:01 Documents
```

اولین فیلدِ خروجی این فرمان، شماره‌ی آی‌نودها را لیست کرده است.

همچنین می‌توانید اطلاعات جزئی‌تر در خصوص فایل را با استفاده از stat به دست بیاورید. این فرمان اطلاعات لازم در خصوص آی‌نود را نیز در اختیارتان قرار می‌دهد.

```
pete@icebox:~$ stat ~/Desktop/
  File: ‘/home/pete/Desktop/’
  Size: 6               Blocks: 0          IO Block: 4096   directory
Device: 806h/2054d      Inode: 140         Links: 2
Access: (0755/drwxr-xr-x)  Uid: ( 1000/   pete)   Gid: ( 1000/   pete)
Access: 2016-01-20 20:13:50.647435982 -0800
Modify: 2016-01-20 20:13:06.191675843 -0800
Change: 2016-01-20 20:13:06.191675843 -0800
 Birth: -
```

**آی‌نودها چطور فایل‌ها را پیدا می‌کنند؟**

می‌دانیم که اطلاعاتمان جایی در دیسک جای خوش کرده، ولی این اطلاعات که در یک تسلسل پیوسته نیستند در نتیجه مجبوریم برای ردیابی آن‌ها از آی‌نودها استفاده کنید. آی‌نودها نشانگری را به سمت بلاک داده‌های فایل شما، در خود دارند. در یک فایل‌سیستم معمولی (و نه همه چون کارکرد آن‌ها با هم متفاوت است) هر آی‌نود شامل ۱۵ نشانگر می‌شود. ۱۲ نشانگر اولیه مستقیماً به بلاک‌های داده اشاره دارند. نشانگر ۱۳ به بلاکی که شامل نشانگرها برای بلاک‌های بیشتر داده است اشاره دارد. نشانگر ۱۴ به یک بلاک تو در توی دیگری از نشانگرها اشاره دارد. و نشانگر ۱۵ باز هم به یک بلاک دیگر از نشانگرها! گیج شدید؟ می‌دانم! دلیل وجود این همه نشانگر تودرتو چیست؟ دلیلش حفظ ساختار یکسان آی‌نود برای هر آی‌نود است، که در کنارش قابلیت اشاره به فایل‌ها با حجم‌های متفاوت را نیز بتواند داشته باشد. اگر یک فایل کوچک دارید، با استفاده از دوزاده نشانگر مستقیم، سریع‌تر می‌توانید پیدایش کنید؛ فایل‌های بزرگ‌تر می‌توانند توسط نشانگرهای تودرتو پیدا شوند. در هر دو صورت ساختار آی‌نود یکسان است.

## تمرین

چند شماره‌ی آی‌نود موجود بر روی سیستم خود را از نظر بگذرانید، کدامشان به صورت معمول زودتر ساخته شده‌اند؟

## سؤال آزمون

چطور می‌توانید بفهمید که چه مقداری آی‌نود بر روی سیستم شما باقی مانده است؟

## پاسخ آزمون

df -i
