# سوار و پیاده کردن فایل‌سیستم‌ها

## محتویات درس

قبل از اینکه بتوانیم محتویات یک فایل‌سیستم را ببینیم، بایستی آن را mount یا به اصطلاح «سوار» کنیم. برای این کار ما به مکان دیوایس، نوع فایل‌سیستم و نقطه‌ی اتصال یا mount point نیاز خواهیم داشت. نقطه‌ی اتصال، یک دایرکتوری بر روی سیستم است که فایل‌سیستم به آن متصل می‌شود. در نتیجه ما می‌خواهیم که دو یار بی‌قرار، یعنی دیوایس را به نقطه‌ی اتصال برسانیم.

ابتدا، نقطه‌ی اتصال را می‌سازیم. برای مثال ما دستور ** mkdir /mydrive** جواب می‌دهد.

```$ sudo mount -t ext4 /dev/sdb2 /mydrive```

به همین سادگی، به همین خوشمزگی! کافی‌ست که به مسیر ‎/mydrive بروید تا محتویات فایل‌سیستم جلوی شما ظاهر شود. در دستور بالا ‎-t نشان‌دهنده‌ی نوع فایل‌سیستم، مقدار بعدی نشان‌دهنده‌ی مکان دیوایس و قسمت آخر هم نشان‌دهنده‌ی نقطه‌ی اتصال است.

برای پیاده کردن یا جدا کردن دیوایس از نقطه اتصال هم می‌توانید از دستور زیر کمک بگیرید:

`$ sudo umount /mydrive```

یا

```$ sudo umount /dev/sdb2```

خاطرتان باشد که هسته‌ی سیستم‌عامل، دیوایس‌ها را به ترتیبی که می‌بیند، لیست می‌کند. حالا اگر اسم دیوایس ما بعد از سوار کردن، تغییر کرد، بایستی چکار کنیم؟ خوشبختانه، دیوایس‌ها یک نام عمومی و البته یکتا که به آن UUID می‌گویند، دارند. با استفاده از این نامِ یکتا، می‌توانیم دیوایس را سوار کنیم.

برای دیدن UUIDهای بلاک‌دیوایس‌ها بر روی سیستم خود، دستور زیر را صادر کنید:

```
pete@icebox:~$ sudo blkid
/dev/sda1: UUID="130b882f-7d79-436d-a096-1e594c92bb76" TYPE="ext4"
/dev/sda5: UUID="22c3d34b-467e-467c-b44d-f03803c2c526" TYPE="swap"
/dev/sda6: UUID="78d203a0-7c18-49bd-9e07-54f44cdb5726" TYPE="xfs"
```

همانطور که مشاهده می‌کنید، نام دیوایس‌ها، به همراه نوع فایل‌سیستم‌شان و شناسه‌ی یکتای آن (UUID)، لیست شده است. این تمام آن اطلاعاتی‌ست که برای سوار کردن دیوایس نیاز داریم.

```$ sudo mount UUID=130b882f-7d79-436d-a096-1e594c92bb76 /mydrive```

اکثر زمان‌ها نیازی به سوار کردن دیوایس با استفاده از شناسه‌ی یکتا نیست و استفاده از نام دیوایس برای اتصال بسیار ساده‌تر و کار راه‌اندازتر خواهد بود. ولی برای زمان‌هایی که قرار است فایل‌سیستم را در حین راه‌اندازی به صورت خودکار سوار کنیم، UUID گزینه‌ی مطمئن‌تری خواهد بود. در این باره در درس پیش رو صحبت خواهیم کرد.

## تمرین

به صفحه‌ی man فرمان‌های mount و umount نگاهی بیندازید. چه گزینه‌های دیگری برای سوار کردن دیوایس وجود دارد.

## سؤال آزمون

از چه دستوری برای اتصال یک فایل‌سیستم استفاده می‌کنیم؟

## پاسخ آزمون

mount
