# symlinks

## محتویات درس

بد نیست با مثالی که در بخش آی‌نود دیدیم، شروع کنیم:

```
pete@icebox:~$ ls -li
140 drwxr-xr-x 2 pete pete 6 Jan 20 20:13 Desktop
141 drwxr-xr-x 2 pete pete 6 Jan 20 20:01 Documents
```

شاید شما هم متوجه شده باشید که ما توجه چندانی به سومین فیلد در خروجی فرمان ls نداشتیم. ولی این فیلد چیست؟ پاسخ ساده است: شمارِ لینک‌هایی که یک فایل دارد! خب این چه معنی می‌دهد؟ بگذارید در خصوص لینک‌ها کمی بیشتر برای‌تان بگویم تا به شمار لینک‌ها هم برسیم.

**Symlinks/سیم‌لینک‌ها**

در سیستم‌عامل ویندوز، چیزی به اسم شورت‌کات یا میانبُر وجود دارد. میانبرها راه‌های دستیابی ثانویه به فایل‌های دیگر محسوب می‌شوند. اگر شما کاری با فایل اصلی بکنید، احتمال اینکه میانبر را به اصطلاح بشکنید یا خراب کنید، وجود دارد. در لینوکس، معادل میانبرها، به اسم سیمبالیک‌لینک (یا سافت‌لینک یا سیم‌لینک) شناخته می‌شوند. سیم‌لینک‌ها به ما اجازه‌ی برقراری یک پیوند بین فایل از طریق نامش را فراهم می‌کنند. نوع دیگر پیوندها، هاردلینک خوانده می‌شود که در اصل یک فایل مجزا با پیوندی به یک آی‌نود هستند. حالا بیایید ببینید که این‌ها در عمل چه هستند.

```
pete@icebox:~/Desktop$ echo 'myfile' > myfile
pete@icebox:~/Desktop$ echo 'myfile2' > myfile2
pete@icebox:~/Desktop$ echo 'myfile3' > myfile3

pete@icebox:~/Desktop$ ln -s myfile myfilelink
pete@icebox:~/Desktop$ ls -li
total 12
  151 -rw-rw-r-- 1 pete pete 7 Jan 21 21:36 myfile
93401 -rw-rw-r-- 1 pete pete 8 Jan 21 21:36 myfile2
93402 -rw-rw-r-- 1 pete pete 8 Jan 21 21:36 myfile3
93403 lrwxrwxrwx 1 pete pete 6 Jan 21 21:39 myfilelink -> myfile
```

در مثال بالا دیدید که من یک سیم‌لینک را با اسم myfilelink که اشاره به myfile دارد، ساختم. سیم‌لینک‌ها با نماد ‎ ->‎ نشان داده می‌شوند. دقت کنید که من یک شماره‌ی جدید آی‌نود به دست آوردم. سیم‌لینک‌ها در حقیقت، فایل‌هایی هستند که به یک نامِ فایل اشاره دارد. زمانی که یک سیم‌لینک را تغییر می‌دهید، آن فایل هم تغییر پیدا می‌کند. شماره‌های آی‌نود برای فایل‌سیستم یکتا هستند و شما نمی‌توانید دو آی‌نود یکسان را در یک فایل‌سیستم داشته باشید. به عبارتی شما نمی‌توانید به فایلی در یک فایل‌سیستم دیگر، با استفاده از آی‌نود پیوندی برقرار کنید. ولی برای ساخت میانبر در بین فایل‌سیستم‌های مختلف چه کاری باید انجام داد؟ از آنجایی که سیم‌لینک‌ها اشاره به نامِ فایل دارند و از آی‌نود برای ایجاد پیوند استفاده نمی‌کنند، می‌توانید از این نمونه لینک‌ها به این منظور استفاده کنید.

**هاردلینک‌ها**

با هم نگاهی به یک مثال از هاردلینک می‌اندازیم.

```
pete@icebox:~/Desktop$ ln myfile2 myhardlink
pete@icebox:~/Desktop$ ls -li
total 16
  151 -rw-rw-r-- 1 pete pete 7 Jan 21 21:36 myfile
93401 -rw-rw-r-- 2 pete pete 8 Jan 21 21:36 myfile2
93402 -rw-rw-r-- 1 pete pete 8 Jan 21 21:36 myfile3
93403 lrwxrwxrwx 1 pete pete 6 Jan 21 21:39 myfilelink -> myfile
93401 -rw-rw-r-- 2 pete pete 8 Jan 21 21:36 myhardlink
```

هاردلینک، یک فایل دیگر را می‌سازد و آن را به آی‌نود مشابه فایل اولیه، پیوند می‌زند. اگر من محتویات myfile2 یا myhardlink را دستکاری کنم، تغییرات در هر دو فایل مشاهده خواهد شد، ولی اگر myfile2 را حذف کنم، فایل هنوز از طریق myhardlink در دسترس خواهد بود. اینجاست که شماره‌ی پیوندی که در خروجی دستور ls دیدیم وارد بازی می‌شود. این شماره‌ی پیوند، تعداد هاردلینک‌هایی‌ست که یک آی‌نود دارد، و زمانی که شما یک فایل را حذف می‌کنید، تعداد آن‌ها کاهش پیدا می‌کند. آی‌نود هم تنها زمانی حذف می‌شود که تمامی فایل‌های پیوند خورده به آن، حذف شوند. زمانی که فایلی را می‌سازید، این عدد ۱/یک خواهد بود، به این معنی که آی‌نود مذکور، تنها به یک فایل (که فایل ساخته شده باشد) اشاره دارد. برخلاف سیم‌لینک‌ها، شما نمی‌توانید از هاردلینک در بین فایل‌سیستم‌های مختلف استفاده کنید چرا که هر فایل‌سیستم شماره‌های آی‌نود مربوط به خود را دارد.

**ساخت یک سیم‌لینک**

```$ ln -s myfile mylink```

برای ساخت یک سیم‌لینک، می‌توانید از دستور ln به همراه ‎-s به معنی سیمبالیک بودن لینک، استفاده کنید. کافیست که بعد از دستور و سوئیچ ‎-s آدرس فایل و سپس نام لینکی که قرار است بسازید را وارد و فرمان را صادر کنید.

**ساخت یک هاردلینک**

```$ ln somefile somelink```

درست به مانند ساخت سیم‌لینک از ln ولی اینبار بدون استفاده از سوئیچ s می‌توانید یک هاردلینک بسازید.

## تمرین

کمی سیم‌لینک و هاردلینک بسازید تا با نحوه‌ی ساختن آن‌ها آشنا شوید و سپس حذفشان کنید.

## سؤال آزمون

از چه دستوری برای ساخت یک سیم‌لینک استفاده می‌کنید؟

## پاسخ آزمون

ln -s
