# نگاهی به System V

## محتوای درس

هدف اصلی init این است که پروسه‌های اساسی سیستم را اجرا یا متوقف کند. سه پیاده‌سازی
اصلی سیستم init در لینوکس عبارتند از System V, Upstart و Systemd. در این درس
می‌خواهیم به پرمصرف‌ترین نسخهٔ init یعنی System V یا Sys V (تلفظ شود 'System
Five') بپردازیم.

در صورتی که روی سیستم‌تان دایرکتوری ‎/etc/inittab را دارید‌، به احتمال زیاد از Sys
V استفاده می‌کنید.

‏Sys V پروسه‌ها را به صورت ترتیبی اجرا و متوقف می‌کند‌، مثلا اگر بخواهید سرویسی به
اسم foo-b را اجرا کنید‌، اول باید مطمئن شوید که foo-a در حال اجرا است. Sys V این
کار را با استفاده از اسکریپت‌هایی که وظیفه‌شان اجرا یا متوقف کردن سرویس‌هاست انجام
می‌دهد. ما می‌توانیم خودمان این اسکریپت‌ها را بنویسیم یا از اسکریپت‌هایی که به صورت
پیش‌فرض همراه سیستم‌عامل هستند برای اجرای سرویس‌های ضروری سیستم استفاده کنیم.‌

ویژگی استفاده از این پیاده‌سازی init‌، در راحتی رفع پیش‌نیاز‌هاست. شما می‌دانید foo-a
قبل از foo-b اجرا می‌شود و می‌توانید پیش‌نیاز‌ها را بر همین اساس مرتب کنید. هر چند
بخاطر این که در هر زمانی تنها یک سرویس در حال اجرا یا متوقف شدن است‌، نمی‌توانید
انتظار بازده زیادی داشته باشید.

وقتی از Sys V استفاده می‌کنید‌، وضعیت ماشین توسط runlevel‌ها که با 0 تا 6
نشانه‌گذاری شده‌اند‌، مشخص می‌شود. تعریف وضعیت هر کدام از این نشانه‌ها می‌تواند بسته
به توزیع مورد استفاده‌تان متفاوت باشد، هر چند عمدتا با وضعیتی شبیه زیر روبرو هستیم:

- ‏0: خاموش
- 1: حالت تک کاربره
- 2: حالت چند کاربره بدون شبکه
- 3: حالت چند کاربره با شبکه
- 4: بدون استفاده
- 5: حالت چند کاربره با شبکه و رابط گرافیکی کاربره
- 6: راه‌اندازی مجدد

وقتی سیستم را روشن می‌کنید، Sys V بر اساس runlevel فعال‌، اسکریپت‌های مربوطه را
اجرا می‌کند. اسکریپت‌ها در شاخه ‎/etc/rc.d/rc[runlevel number].d و یا ‎/etc/init.d
قرار دارند. اسکریپت‌هایی که نام‌شان با S شروع می‌شوند مشخص کننده Start هستند و
در زمان روشن شدن سیستم اجرا می‌شوند. همین‌طور اسکریپت‌هایی که با K شروع می‌شوند در
زمان خاموش کردن سیستم. در ادامه این نام‌، اعدادی قرار دارند که نشان دهنده رتبه
اجرای اسکریپت در ترتیب اجرا هستند.

برای مثال:

```
pete@icebox:/etc/rc.d/rc0.d$ ls
K10updates  K80openvpn        
```

می‌بینیم که در زمان تغییر runlevel به صفر یا همان وضعیت خاموش‌، ماشین تلاش می‌کند
که اول سرویس updates و پس از آن سرویس openvpn را خاموش کند. برای پیدا کردن
runlevel‌ای که ماشین‌تان در آن شروع به بوت می‌کند‌، می‌توانید runlevel پیش‌فرض را در
‎/etc/inittab مشاهده کنید. شما همچنین می‌توانید این مقدار را بسته به نیاز خود
ویرایش کنید.

یک نکتهٔ قابل توجه در خصوص System V این است که این پیاده‌سازی کم کم در حال
بازنشسته شدن در اکثر توزیع‌های مرسوم است. اما سیستم‌های جایگزین برای پشتیبانی از
سرویس‌هایی که تنها به صورت runlevel اجرا یا متوقف می‌شوند‌، راهکارهایی دارند.

## تمرین

اگر از System V استفاده می‌کنید‌، runlevel پیش‌فرض ماشین خود را به چیز دیگری تغییر دهید و ببینید چه چیزی رخ می‌دهد.

## سوال آزمون

معمولا از چه runlevel‌ای برای خاموش کردن سیستم استفاده می‌شود؟

## پاسخ آزمون

0
