# وظایف Upstart

## محتوای درس

‏Upstart می‌تواند رویداد‌ها (events) و وظایف (jobs) متعددی را جهت اجرا فراخوانی
کند. اما متاسفانه راهکار آسانی برای پیدا کردن منشا یک وظیفه یا رویداد وجود
ندارد‌ و برای این منظور باید تنظیمات مربوط به وظایف در ‎/etc/init را بررسی کنید.
اکثر مواقع‌، نیازی به بررسی فایل‌های تنظیمات وظایف نیست‌، اما می‌توانید برای مدیریت
راحت‌تر وظایف از آن‌ها کمک بگیرید. دستورات کاربردی زیادی در سیستم Upstart وجود
دارد که می‌توانید از آن‌ها استفاده کنید.

### دیدن وظایف

```
$ initctl list

shutdown stop/waiting
console stop/waiting
...
```

لیستی از وظایف موجود در Upstart به همراه وضعیت اعمال شده روی آن‌ها را مشاهده
می‌کنید. در هر خط‌، اسم وظیفه اولین مقدار موجود است‌، و بخش دوم (قبل از /) هدف
نهایی سرویس را نشان می‌دهد. همچنین‌، فیلد سوم (بعد از /) نشانگر وضعیت فعلی وظیفه
است. بر همین اساس می‌بینیم که وظیفهٔ shutdown سیستم در نهایت به حالت stop تبدیل
خواهد شد ولی فعلا در حالت waiting است. حالات وظیفه و اهداف‌شان زمانی که شما آن‌ها
را اجرا یا متوقف می‌کنید تغییر می‌کنند.

### بررسی وضعیت یک وظیفه مشخص

```
$ initctl status networking
networking start/running
```

ما به جزئیات چگونگی توسعه تنظیمات وظیفه‌های Upstart نمی‌پردازیم‌، اما به هر حال
می‌دانیم که با استفاده از همین تنظیمات است که وظایف می‌توانند‌، اجرا‌، متوقف یا
راه‌اندازی مجدد شوند. این وظایف همچنین با فراخوانی رویداد‌ها می‌توانند وظایف دیگر را نیز
اجرا کنند. در ادامه به بررسی دستوراتی جهت مدیریت Upstart می‌پردازیم‌، اما اگر
بیشتر کنجکاو هستید، می‌توانید فایل‌های ‎.conf را بیشتر بررسی کنید.

### اجرای یک وظیفه

```
$ sudo initctl start networking
```

### متوقف کردن یک وظیفه

```
$ sudo initctl stop networking
```

### راه‌اندازی مجدد یک وظیفه

```
$ sudo initctl restart networking
```

### فراخوانی یک رویداد

```
$ sudo initctl emit some_event
```

## تمرین

لیست وظایف Upstart خود را بررسی کنید‌، حالا وضعیت یک وظیفه را با استفاده از
دستورات بالا تغییر دهید و ببینید چه رخ می‌دهد.

### سوال آزمون

برای راه‌اندازی مجدد یک سرویس به اسم Peanut از چه دستوری استفاده می‌کنید؟


```
sudo initctl restart peanuts
```
