# اشتراک فایل

## محتوای درس

معمولا شما تنها کامپیوتر روی شبکه نیستید‌، خصوصا زمانی که در یک محیط تجاری مشغول
کارید. وقتی می‌خواهیم داده‌ای را از یک ماشین به ماشین دیگر منتقل کنیم‌، گاها ممکن
است استفاده از یک درایو USB و کپی دستی راه‌کار معقولی به نظر برسد. ولی اکثرا، اگر
می‌خواهید فایل را بین ماشین‌هایی که روی یک شبکه قرار دارند منتقل کنید‌، استفاده از
روش اشتراک فایل روی شبکه راه‌حل بهتری است. 

در این درس به بررسی چند روش مختلف کپی فایل بین ماشین‌های روی یک شبکه خواهیم
پرداخت. در مورد روش‌های سادهٔ کپی فایل صحبت می‌کنیم و در ادامه به چگونگی سوار کردن
یک دایرکتوری روی ماشین‌های شبکه که به صورت یک درایو جدا عمل می‌کند می‌پردازیم. 

یک ابزار اشتراک فایل ساده‌، دستور `scp` است. معنی نام این دستور، کپی امن یا
secure copy است. روش کار آن نیز دقیقا مشابه دستور `cp` است‌، با این تفاوت که به
شما امکان کپی فایل از روی ماشین‌های مختلف روی شبکه را می‌دهد. بستر اصلی کار کرد
این دستور با استفاده از `ssh` است، در نتیجه روش شناسایی و امنیت آن نیز دقیقا
مطابق با همین بستر است.

### کپی فایل از یک ماشین به ماشین دیگری روی شبکه

```
$ scp myfile.txt username@remotehost.com:/remote/directory
```

### کپی فایل از یک ماشین روی شبکه به ماشین فعلی

```
$ scp username@remotehost.com:/remote/directory/myfile.txt /local/directory
```

### کپی یک دایرکتوری از ماشین حاضر به ماشین دیگری روی شبکه

```
$ scp -r mydir username@remotehost.com:/remote/directory
```

## تمرین

سعی کنید با استفاده از دستور `scp` فایل‌هایی را بین چند ماشین روی شبکه منتقل کنید. 

## سوال آزمون

از چه دستوری می‌توانید برای کپی امن فایل‌ها روی یک شبکه استفاده کنید؟

## پاسخ آزمون

scp
