# rsync

## محتوای درس

ابزار دیگری که می‌توان برای کپی داده بین ماشین‌های مختلف استفاده کرد rsync (کوتاه
شده remote synchronization) نام دارد. Rsync بسیار شبیه به scp عمل می‌کند ولی یک
تفاوت عمده را شامل می‌شود. Rsync از یک الگوریتم ویژه برای بررسی دیتای در حال کپی
استفاده می‌کند که نهایتا منجر به انتقال تنها تفاوت‌های داده در مبدا و مقصد می‌شود.
برای مثال فرض کنید در حال انتقال فایل‌ها از روی شبکه‌، مشکلی روی ارتباط شبکهٔ شما
رخ داد و در نتیجه آن کپی فایل‌ها در میانه راه متوقف شد. به جای کپی همهٔ فایل‌ها از
اول‌، rsync این امکان را فراهم می‌کند که تنها بخش‌هایی که به درستی کپی نشده‌اند کپی
شود.

همچنین rsync یک پارچگی فایل‌های کپی شده را با استفاده از checksum بررسی می‌کند و
شما می‌توانید از سلامت فایل‌های کپی شده اطمینان داشته باشید. این تغییر به ظاهر
کوچک‌، انعطاف‌پذیری بیشتری را در فرآیند انتقال فایل فراهم می‌کند و rsync را به یک
ابزار مناسب جهت همگام‌سازی فایل‌های روی ماشین‌های شبکه‌، پشتیبان‌گیری و انتقال
فایل‌های بزرگ تبدیل می‌کند.

بعضی از آپشن‌های پرکاربرد rsync به شرح زیر هستند: 

- ‏v: خروجی بیشتر لاگ‌ها 
- r: کپی فایل‌های داخل یک دایرکتوری و زیرشاخه‌های آن‌ها
- h: نمایش سایز فایل‌ها مناسب برای کاربر
- z: فشرده سازی فایل‌ها جهت آسان‌تر کردن انتقال فایل‌ها که روش بسیار مناسبی برای
  انتقال فایل روی شبکه‌های با سرعت پایین‌تر است.
  
### کپی/همگام‌سازی فایل‌های روی یک ماشین

```
$ rsync -zvr /my/local/directory/one /my/local/directory/two
```

### کپی/همگام‌سازی فایل‌ها از ماشین حاضر به یک ماشین دیگر روی شبکه

```
$ rsync /local/directory username@remotehost.com:/remote/directory
```

### کپی/همگام‌سازی فایل‌ها از یک ماشین دیگر به ماشین حاضر

```
$ rsync username@remotehost.com:/remote/directory /local/directory
```

## تمرینات

از rsync برای کپی یک دایرکتوری به دایرکتوری‌ای دیگر بهره بگیرید. توجه داشته باشید
که اشتباها یک دایرکتوری مهم را بازنویسی نکنید!

## سوال آزمون

از چه دستوری می‌توان برای پشتیبان‌گیری امن فایل‌ها استفاده کرد؟

## پاسخ آزمون

rsync
