# سامبا

## محتوای درس

مدت‌ها ییش در نتیجهٔ رفع نیاز اشتراک فایل بین ماشین‌های لینوکسی و ویندوزی‌، پروتکل
SMB یا Server Message Block زاده شد. SMB برای اشتراک فایل سیستم‌های ویندوزی (مک
نیز از SMB برای اشتراک فایل بهره می‌گیرد) استفاده می‌شد و بعد‌ها پاک‌سازی و بهینه‌تر
شد تا به صورت پروتکلی به نام CIFS (Common Internet File System) در آمد. 

‏Samba ابزاری لینوکسی برای کار با CIFS است. همچنین علاوه بر اشتراک فایل‌، قابلیت
اشتراک‌گذاری منابع دیگری چون پرینتر‌ها را نیز داراست. 

### ساخت یک اشتراک شبکه‌ای توسط سامبا

بیایید مراحل ساخت یک اشتراک شبکه‌ای که قابلیت دسترسی توسط ماشین‌های ویندوزی را
داراست بررسی کنیم:

#### نصب سامبا

```
$ sudo apt update
$ sudo apt install samba
```

#### تنظیم smb.conf

فایل تنظیم سامبا در مسیر `‎/etc/samba/smb.conf` قرار دارد، که وظیفهٔ تعریف
دایرکتوری‌های به اشتراک گذارده شده، اجازه‌های دسترسی و برخی تنظیمات دیگر را بر
عهده دارد. این فایل به صورت پیش‌فرض شامل بسیاری از مثال‌ها به صورت کامنت شده است
که می‌توانید از آن‌ها برای آشنایی بیشتر با تنظیمات و تنظیم سیستم اشتراک خود بهره بگیرید. 

```
$ sudo vi /etc/samba/smb.conf
```

#### تنظیم رمز عبور برای سامبا

```
$ sudo smbpasswd -a [username]
```

#### ساخت یک دایرکتوری مشترک

```
$ mkdir /my/directory/to/share
```

#### راه‌اندازی مجدد سامبا

```
$ sudo service smbd restart
```

#### دسترسی به یک اشتراک سامبا از طریق ویندوز

در ویندوز فقط آدرس اشتراک سامبا را در run اجرا کنید:

```
\\HOST\sharename
```

#### دسترسی به یک اشتراک سامبا/ویندوز از طریق لینوکس

```
$ smbclient //HOST/directory -U user
```

بستهٔ سامبا شامل یک ابزار خط فرمان به نام `smbclient` می‌شود که می‌توانید از آن
برای دسترسی به هر سرور سامبا (چه ویندوز و چه لینوکس) بهره بگیرید. پس از اتصال
می‌توانید دایرکتوری‌ها را جستجو کرده و یا انتقال فایل‌های مورد نظر را انجام دهید. 

#### متصل کردن یک اشتراک سامبا به سیستم

به جای انتقال تک به تک فایل‌ها‌، می‌توانید اشتراک سامبا را روی سیستم خود سوار (mount) کنید:

```
$ sudo mount -t cifs servername:directory mountpount -o user=username,pass=password
```

## تمرین

یک اشتراک سامبا ایجاد کنید و با ویرایش فایل `smb.conf` با تنظیمات آن آشنا شوید. 

## سوال آزمون

از کدام پروتکل می‌توان برای اشتراک فایل بین ویندوز و لینوکس بهره گرفت؟

## پاسخ آزمون

CIFS
