# کامپایل سورس کد

## محتوای درس

گاها پیش می‌آید که نیاز به نصب بسته‌ای داریم که تنها به صورت سورس کد منتشر می‌شود‌.
برای استفاده از آن سورس کد نیاز به استفاده از چند دستور جهت کامپایل و نصب آن روی
سیستم خود دارید.

اولین کار مورد نیاز ما نصب بسته‌ها و دستوراتی است که اجازهٔ کامپایل سورس کد را به
ما می‌دهند:

```
$ sudo apt install build-essential
```

وقتی این کار را انجام دادید‌، محتوای بستهٔ مورد نظر‌تان را از حالت فشرده که معمولا
به صورت `‎.tar.gz` ارائه می‌شود خارج کنید.

```
$ tar -xzvf package.tar.gz
```

قبل از انجام هر کاری‌، نگاهی به فایل‌های `README` یا `INSTALL` که عموما همراه
فایل‌های داخل بسته هستند بیاندازید.

بسته به متد کامپایل مورد استفاده توسط توسعه دهنده‌، ممکن است که نیاز باشد از
دستور متفاوتی برای کامپایل بسته استفاده کنید.

به هر حال‌، عمدهٔ بسته‌هایی که نیاز به کامپایل دارند از یک روش مرسوم استفاده می‌کنند
که ما در ادامه به شرح آن خواهیم پرداخت:

درون محتوای بستهٔ استخراج شده یک اسکریپت کانفیگ وجود دارد‌، این اسکریپت برای بررسی
نیازمندی‌های بسته روی سیستم و این که چیز مورد نیازی از قلم نیافته باشد استفاده
می‌شود. در صورت وجود چنین مشکلی این اسکریپت اخطار مناسبی بر می‌گرداند تا مشکلات آن
نیازمندی‌ها را رفع کنید.

```
$ ./configure
```

توجه داشته باشید که مقدار `/.` اجازهٔ اجرای اسکریپت از دایرکتوری حاضر را می‌دهند. 

```
$ make
```

همچنین فایل دیگری به اسم `Makefile` درون محتوای بسته قرار داده می‌شود که شامل
دستورات مورد نیاز برای کامپایل نرم‌افزار است. وقتی شما دستور `make` را اجرا
می‌کنید‌، این دستور فایل ذکر شده را پیدا کرده و برای کامپایل بسته از آن کمک می‌گیرد. 

```
$ sudo make install
```

نهایتا این دستوری است که وظیفهٔ نصب بستهٔ ذکر شده را بر عهده دارد. فایل‌های مناسب
را در محل دقیقشان روی سیستم کپی می‌کند.

همچنین برای حذف نرم‌افزار از روی سیستم‌تان می‌توانید از دستور زیر کمک بگیرید:

```
$ sudo make uninstall
```

توجه داشته باشید که وقتی از `make install` استفاده می‌کنید‌، ممکن است متوجه تمامی
روند اجرا شده روی سیستم خود نشوید. در زمان پاک کردن یک بسته، ممکن است همه چیزی
که در پس زمینه روی سیستم شما نصب شده‌اند پاک نشود چون شما ندیدید که در واقع چه
چیز‌هایی روی سیستم اضافه شده‌اند. بهتر است به جای استفاده از `make install` از
دستور `checkinstall` استفاده کنید. این دستور یک فایل `‎.deb` از بستهٔ حاضر ایجاد
می‌کند که می‌توانید به راحتی روی سیستم نصب یا حذف‌اش کنید.

```
$ sudo checkinstall
``` 

این دستور در واقع یک `make install` اجرا کرده و با استفاده از خروجی آن یک بسته
`‎.deb` ایجاد می‌کند و سپس اقدام به نصب آن می‌کند. این کار حذف بسته در آینده را
راحت‌تر می‌کند.

## تمرین

یک سورس کد نرم‌افزار (از یک منبع معتبر) پیدا کرده و اقدام به نصب‌اش کنید. 

## سوال آزمون

از چه دستوری باید به جای `make install` استفاده شود؟

## پاسخ آزمون

checkinstall
