# tar و gzip

## محتوای درس

قبل از بررسی چگونگی نصب بسته‌ها و انواع مدیر بسته‌ها‌، نیاز است که به راه حل‌های
آرشیو و فشرده‌سازی فایل‌ها بپردازیم‌، چرا که عمدتا وقتی نرم‌افزار جدیدی روی اینترنت
می‌یابید‌، با این فشرده‌ساز‌ها روبرو می‌شوید.

احتمالا می‌دانید که یک فایل آرشیو چیست و انواعی همچون ‎.rar و ‎.zip را دیده‌اید.
این‌ها فایل‌های آرشیو هستند و تعدادی فایل را در خود نگهداری می‌کنند ولی به قالب یک
فایل موسوم به آرشیو منتشر می‌شوند.

### فشرده‌سازی فایل‌ها با استفاده از gzip

‏gzip برنامه‌ای است که برای فشرده‌سازی فایل روی لینوکس استفاده می‌شود و فایل‌های
نهایی تولید شده توسط آن با پسوند ‎.gz شناخته می‌شوند.

برای فشرده‌سازی یک فایل می‌توانید از دستور زیر استفاده کنید:

```
$ gzip mycoolfile
```

و برای خارج کردن یک فایل از حالت فشرده نیز از دستور زیر بهره بگیرید:

```
$ gunzip mycoolfile.gz
```

### ساخت فایل‌های آرشیو tar

متاسفانه دستور gzip قادر به اضافه کردن چند فایل در یک آرشیو نیست. به همین منظور
باید از برنامهٔ tar که چنین قابلیتی را فراهم می‌کند استفاده کنیم. وقتی توسط tar یک
فایل آرشیو می‌سازید‌، نتیجهٔ نهایی با پسوند ‎.tar شناخته می‌شود.


```
$ tar cvf mytarfile.tar mycoolfile1 mycoolfile 2
```

در این دستور آرگومان‌های استفاده شده به شرح زیر هستند:

- ‏c: بساز
- v: به برنامه بگو که تمام روند ساخت فایل آرشیو را گزارش کند.
- f: نام فایل نتیجهٔ نهایی که بعد از این آرگومان مشخص شده. توجه داشته باشید که
  لازم است این نام را در هنگام ساخت یک tar جدید شما انتخاب کنید.
  
### خارج کردن فایل‌ها از یک آرشیو tar

برای خارج کردن فایل‌ها می‌توانید از دستور زیر بهره بگیرید: 

```
$ tar xvf mytarfile.tar
```

آرگومان‌های به کار رفته شده در این دستور به شرح زیر هستند:

- ‏x: خارج کن
- v: به برنامه بگو که تمام روند خارج کردن فایل‌ها از آرشیو را گزارش کند. 
- f: نام فایلی آرشیوی که قصد خارج کردن محتوایش را داریم. 

### فشرده‌سازی و خارج کردن محتوای فایل‌های فشرده شده با استفاده از tar و gzip

زمان‌هایی پیش می‌آید که با فایل‌هایی مواجه می‌شوید که با tar آرشیو شده و با gzip
فشرده شده‌اند که فرمی به صورت `mycompressedarchive.tar.gz` دارند. تمام چیزی که
برای خارج کردن این فایل‌ها نیاز است، به ترتیب حذف فشرده‌سازی و سپس خارج کردن
فایل‌ها از آرشیو نتیجه است. خوشبختانه با پیشرفت‌های اخیر دستور tar، همان دستور
خارج کردن فایل‌ها از یک آرشیو که در مرحلهٔ قبل توضیح‌اش دادیم‌، قادر به انجام این کار است:

```
tar xvf mycompressedarchive.tar.gz
```

دستور tar ابزار قدرتمندی است که احتمالا در بسیاری مواقع ممکن است آن را فراموش کنید. [این کارتون xkcd به خوبی از وضعیت را شرح می‌دهد.](https://xkcd.com/1168)

### دیگر ابزار‌ها

در طول مراحل سفرتان در لینوکس، احتمالا با انواع دیگر روش‌های فشرده‌سازی نظیر
bzip2, compress, zip و… آشنا می‌شوید. این ابزار‌ها کمی غیر مرسوم‌تر هستند‌، ولی توجه
داشته باشید که هر کدام از این انواع ابزار‌های مربوط به خود را جهت فشرده‌سازی و
خارج کردن فایل‌ها از حالت فشرده دارند.

## تمرین

خود را از طریق مستندات دستور tar با این ابزار آشنا کنید و با دیگر آرگومان‌های موجود آشنا شوید. 

## سوال آزمون

از کدام آرگومان tar برای ساخت یک فایل آرشیو جدید استفاده می‌شود؟

## Quiz Answer

c
