# cp (Copy)

## Lesson Content

Давайте начнем создавать копии файлов. Во многом похоже на копирование и вставку файлов в других операционных системах, оболчка дает нам более простой способ сделать это.

<pre>$ cp mycoolfile /home/pete/Documents/cooldocs</pre>

mycoolfile - это файл, который вы хотите скопирова и /home/pete/Documents/cooldocs - это то, куда вы хотите скопировать файл.

Вы можете копировать несколько файлов и директорий используя wildcard (подстановочный знак). Wildcard - символ, который может быть заменен на выбранный шаблон, давая большую гибкость при поиске. Вы можете использовать подстановочные знаки в любой команде для большей гибкости.

<ul>
<li>* wildcard всех wildcard'ов, используется для обозначения любых символов или строк</li>
<li>? используется для обозначения одного символа</li>
<li>[] используется для обозначения любого символа в скобках</li>
</ul>

<pre>$ cp *.jpg /home/pete/Pictures</pre>

Это скопирует все файлы с расширением .jpg в текущей директории в каталог Pictures.

Полезно дополнить команду флагом -r (recursively/рекурсивно), которая рекурсиво скопирует файлы и директории внутри каталога.

Попробуйте выполнить cp на директории, которая содержит несколько файлов в вашу директорию Documents. Не сработало? Это потому что необходимо также скопировать файлы и каталоги с флагом -r.

<pre>$ cp -r Pumpkin/ /home/pete/Documents</pre>

Заметьте одну вещь, если вы копируете файл в директорию, которая содержит файл с таким же именем, то этот файл будет перезаписан на то, что вы копируете. Это плохо, если у вас есть файл, который вы не хотите случайно перезаписать. Вы можете использовать флаг -i (interactive/интерактивно), чтобы получить запрос на перезапись файла.

<pre>$ cp -i mycoolfile /home/pete/Pictures</pre>

## Exercise

Скопируйте несколько файлов, будьте осторожны, не перезапишите что-нибудь важное.

## Quiz Question

Какой флаг вам нужен, чтобы скопировать всю директорию?

## Quiz Answer

-r