# env (Environment)

## Lesson Content

Запустите следующую команду:

<pre>$ echo $HOME</pre>

Вы должны увидеть путь к вашей домашней директории, моя выглядит как /home/pete.

Что насчет этой команды?

<pre>$ echo $USER </pre>

Вы должны увидеть ваше имя пользователя!

Откуда эта информация берется? Она берется из переменных среды (environment variables).  Вы можете увидеть их, написав

<pre>$ env </pre>

Эта команда выведет кучу информации о переменных среды, которые вы задали. Эти переменные содержат полезную информацию, которую оболочка и другие процессы могут использовать.

Вот короткий пример:

<pre>
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/bin
PWD=/home/user
USER=pete
</pre>


Одна, особенно важная, переменная - переменная PATH (путь). Вы можете обращаться к этой переменной, добавив $ перед именем переменной, как тут:

<pre>
$ echo $PATH
/usr/local/sbin:/usr/local/bin:/usr/sbin:/bin
</pre>

Это вернет список путей, разделенных двоеточием, которые ваша система ищет при запуске команды. Давайте скажем, что вы вручную скачали и установили пакет (package) из интернета, поместили его в нестандартную директорию и хотите запустит его командой, вы пишите $ coolcommand и консоль сообщает вам, что команда не найдена. Это довольно глупо искать исполняемый файл (binary) в каталоге, зная, что он существует. Вот, что происходит, когда переменная $PATH не проверяет этот каталог на наличие исполняемого файла, показывая ошибку.

Давайте скажем, что у вас тонна исполняемых файлов, которые вы хотите запустить из вашей директории, вы можете просто изменить переменную PATH, чтобы включить эту директорию туда.


## Exercise

Какой будет вывод этой команды? Почему?
<pre>$ echo $HOME</pre>

## Quiz Question

Как вы можете увидеть переменные среды?

## Quiz Answer

env
