# stderr (Standard Error)

## Lesson Content

Давайте попробуем что-нибудь другое, давайте попробуем вывести список содержимого директории, которая не существует на вашей системе и перенаправим вывод в файл peanuts.txt снова.

<pre>$ ls /fake/directory > peanuts.txt </pre>

Что вы должны увидеть:

<pre>ls: cannot access /fake/directory: No such file or directory</pre>

Сейчас вы возможно думаете, должно ли это сообщение отправиться в файл? Существует другой I/O поток, который называется стандартной ошибкой (stderr / standart error). По-умолчанию stderr отправляет его вывод на экран, но это совершенно другой поток, по отношению к stdout. Так что вам нужно перенаправить его другим способом.

К сожалению, редиректор не такой приятный, как <b>&lt;</b> или <b>&gt;</b>, но довольно близок к этому. Нам нужно использовать дескрипторы файлов. Дескриптор файла - неотрицательное число, которое используется для доступа к файлу или потоку. Мы узнаем об этом подробнее позже, но сейчас вам достаточно знать, что дескрипторы файлов для stdin, stdout и stderr  - 0, 1 и 2 соответственно.

Так вот, если мы хотим перенаправить наш stderr в файл, мы можем использовать это:

<pre>$ ls /fake/directory 2> peanuts.txt</pre>

Вы должны увидеть только stderr сообщения в peanuts.txt.

Что если я хочу увидеть stderr и stdout в одном файле? Это возможно, с дескрипторами файлов:

<pre>$ ls /fake/directory > peanuts.txt 2>&1</pre>

Это отправит результат ls /fake/directory в файл peanuts.txt, а затем перенаправит stderr в stdout по 2>&1. Важен порядок операций, 2>&1 отправляет stderr в направленный стандартный вывод. В этом случае stdout нацелен на файл, так что 2>&1 также отправит stderr в файл. Теперь если вы откроете peanuts.txt, вы увидите и stderr, и stdout. В нашем случае, команда выше выводит только stderr.

Существует более короткий способ перенаправить stdout и stderr в файл:

<pre>$ ls /fake/directory &> peanuts.txt</pre>

Теперь, что если я не хочу держать весь этот хлам и хочу полностью избавиться от сообщений stderr? Вы можете перенаправить вывод в специальный файл, называнный /dev/null, который уничтожает любой ввод.

<pre>$ ls /fake/directory 2> /dev/null</pre>

## Exercise

Что делает следующая команда?

<pre>$ ls /fake/directory >> /dev/null 2>&1</pre>

## Quiz Question

Какой оператор используется для перенаправления stderr?

## Quiz Answer

2>
