<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
    xmlns:op="utc.fr:ics/opale3" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
    version="1.0">
    <xsl:output method="xml" indent="yes" encoding="iso-8859-1"/>

    <xsl:template match="lesson_part">
        <sc:item xmlns:sc="http://www.utc.fr/ics/scenari/v3/core">
            <op:courseUa xmlns:op="utc.fr:ics/opale3" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive">
                <xsl:apply-templates/>
            </op:courseUa>
        </sc:item>
    </xsl:template>

    <xsl:variable name="var1"><xsl:value-of select="/lesson_part/title"/></xsl:variable>

    <xsl:template match="title">
        <op:uM>
            <sp:title><xsl:apply-templates/></sp:title>
        </op:uM>
    </xsl:template>

    <xsl:template match="lessonCore">
        <sp:courseUc>
            <op:expUc>
                <op:uM>
                    <sp:title><xsl:value-of select="$var1"/></sp:title>
                </op:uM>
                <sp:pb>
                    <op:pb>
                        <sp:info>
                            <op:pbTi/>
                            <op:res>

                                <xsl:apply-templates/>
                            </op:res>
                        </sp:info>
                    </op:pb>
                </sp:pb>
            </op:expUc>
        </sp:courseUc>

    </xsl:template>

    <xsl:template match="paragraph">
        <sp:txt>
            <op:txt>
                <sc:para xml:space="preserve"><xsl:apply-templates/></sc:para>
            </op:txt>
        </sp:txt>
    </xsl:template>

    <xsl:template match="listing">
        <sp:listing>
            <op:code>
                <sc:code mimeType="text/x-sh">aaaa
                    <xsl:apply-templates/>
                </sc:code>
            </op:code>
        </sp:listing>
    </xsl:template>

    <xsl:template match="exercise">
        <sp:practUc>
            <op:practUc>
                <op:exeM/>
                <sp:desc>
                    <op:sTitle>
                        <sc:fullTitle><xsl:value-of select="$var1"/></sc:fullTitle>
                    </op:sTitle>
                    <op:res>
                        <xsl:apply-templates/>
                    </op:res>
                </sp:desc>
            </op:practUc>
        </sp:practUc>                                
    </xsl:template>
    <xsl:template match="quiz">
        <sp:trainUcField>
            <op:field>
                <op:exeM/>
                <xsl:apply-templates/>
            </op:field>
        </sp:trainUcField>
    </xsl:template>
    <xsl:template match="question">
        <sc:question>
            <op:res>
                <sp:txt>
                    <op:txt>
                        <sc:para xml:space="preserve"><xsl:apply-templates/></sc:para>
                    </op:txt>
                </sp:txt>
            </op:res>
        </sc:question>
    </xsl:template>
    <xsl:template match="answer">
        <sp:asw>
            <sc:SFSolution>
                <sc:value><xsl:apply-templates/></sc:value>
            </sc:SFSolution>
        </sp:asw>
    </xsl:template>

    <xsl:template match="unorderedList">
        <sp:txt>
			<op:txt>
                <sc:itemizedList>
                    <xsl:apply-templates/>
                </sc:itemizedList>
            </op:txt>
        </sp:txt>
    </xsl:template>

    <xsl:template match="listElement">

        <sc:listItem>
            <sc:para xml:space="preserve"><xsl:apply-templates/></sc:para>
        </sc:listItem>
    </xsl:template>
</xsl:stylesheet>
